﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using TXTextControl;

namespace _10455_Table
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void 表格IDToolStripMenuItem_Click(object sender, EventArgs e)
        {
            TXTextControl.Table table = textControl1.Tables.GetItem();
            if (table == null)
            {
                MessageBox.Show("你没有选中表格！");
            }
            else
            {
                MessageBox.Show("你选中表格ID为：" + table.ID.ToString());
            }
        }

        private void 单元格范围ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            TXTextControl.Table table = textControl1.Tables.GetItem();
            if (table == null)
            {
                MessageBox.Show("你没有选中表格！");
            }
            else
            {
                // 获取选中的单元格坐标
                string cells = GetSelectedCells();
                MessageBox.Show(cells);
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // 插入表格
            textControl1.ResetContents();
            textControl1.Tables.Add(5, 4, 1000);
        }

        // 获取选中的单元格坐标
        private string GetSelectedCells()
        {
            StringBuilder sb = new StringBuilder();

            Table table = textControl1.Tables.GetItem();

            Selection curSelection = new Selection(textControl1.Selection.Start, textControl1.Selection.Length);
            textControl1.Selection.Length = 0;

            // 获取选中单元格的起始单元格坐标
            int iTableStartRow = table.Cells.GetItem().Row;
            int iTableStartCol = table.Cells.GetItem().Column;

            if (curSelection.Length != 0)
            {
                textControl1.Selection.Start = curSelection.Start + curSelection.Length - 1;
            }

            // 获取选中单元格截止单元格坐标
            int iTableEndRow = table.Cells.GetItem().Row;
            int iTableEndCol = table.Cells.GetItem().Column;

            // 循环所有单元格以检查当前单元格是否在选中单元格范围内
            foreach (TableCell cell in textControl1.Tables.GetItem().Cells)
            {
                if (cell.Row >= iTableStartRow && cell.Row <= iTableEndRow && cell.Column <= iTableEndCol && cell.Column >= iTableStartCol)
                    sb.Append(string.Format("[{0},{1}] ", cell.Row, cell.Column));
            }

            return sb.ToString();
        }
    }
}
